#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;


int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++) {
		int n, m;
		cin >> n >> m;
		int result = n;
		typedef pair < int, int > edge_t;
		vector < edge_t > allEdges(m);
		vector < vector < edge_t > > edges(n);
		for(int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v;
			--u; --v;
			edges[u].pb(mp(v, i));
			edges[v].pb(mp(u, i));
			allEdges[i] = mp(u, v);
		}
		const int inf = n + 1;
		queue < int > q;
		vector < int > distances(n);
		for(int remove = 0; remove < m; remove++) {
			int start = allEdges[remove].first;
			int end = allEdges[remove].second;
			fill(distances.begin(), distances.end(), inf);
			distances[start] = 0;
			q.push(start);
			while(!q.empty()) {
				int u = q.front();
				q.pop();
				for(auto e : edges[u]) {
					if(distances[e.first] == inf && e.second != remove) {
						distances[e.first] = distances[u] + 1;
						q.push(e.first);
					}
				}
			}
			result = min(result, distances[end] + 1);
		}
		cout << result << endl;
	}
	return 0;
}