#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int SZ = 105;
const int MAX_N = 100005;
const int MOD = 1000000000;

int n, m, k, s, a[SZ], b[SZ], dp[MAX_N], last[MAX_N];

inline void update(int d, int v, int test, int type) {
    if (d > m) {
        return;
    }

    if (last[d] != test) {
        dp[d] = 0;
        last[d] = test;
    }

    if (d == m && !type) {
        return;
    }

    dp[d] += v;

    if (dp[d] >= MOD) {
        dp[d] -= MOD;
    }
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;

    cin >> tests;

    for (int test = 1; test <= tests; test++) {
        cin >> n >> m >> k;

        for (int i = 0; i < k; i++) {
            cin >> a[i];
        }

        cin >> s;

        for (int i = 0; i < s; i++) {
            cin >> b[i];
        }

        sort(a, a + k);
        k = unique(a, a + k) - a;

        sort(b, b + s);
        s = unique(b, b + s) - b;

        dp[n] = 1;

        for (int i = n; i <= m / 2; i++) {
            if (last[i] != test) {
                continue;
            }

            for (int j = 0; j < k; j++) {
                update(i + a[j], dp[i], test, 0);
            }

            for (int j = 0; j < s; j++) {
                update(i * b[j], dp[i], test, 1);
            }
        }

        if (last[m] != test) {
            cout << 0 << endl;
        } else {
            cout << dp[m] << endl;
        }
    }

    return 0;
}
