#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

long long powmod(long long a, long long b, long long mod)
{
	long long res = 1;
	while (b > 0)
	{
		if (b & 1) {
			res = (res * a) % mod;
		}
		b >>= 1;
		a = (a * a) % mod;
	}
	return res;
}

long long inv(long long a, long long b)
{
	if (b == 1)
		return 0;
	a %= b;
	long long fi = 1;
	for(long long i = 2; i * i <= b; i++)
	{
		if (b % i == 0)
		{
			long long p1 = 1, p2 = 1;
			while ( b % i == 0)
			{
				p2 = p1;
				p1 *= i;
				b /= i;
			}
			fi *= p1 - p2;
		}
	}
	if (b > 0)
		fi *= b - 1;
	return powmod(a, fi - 1, b);
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
	int tests;
	cin >> tests;
	for (int test=0; test< tests; test++)
	{
		long long n;
		cin >> n;
		long long k1=2;
		long long k2=1;
		long long a;
		long long b;
		long long bestb=(n+1)/2;
		long long besta=n-bestb;
		while (k1+k2<=n)
		{
			//cout << k1 << " " << k2 << endl;
			long long x=(inv(k2,k1)*n)%k1;
			//cout << x << endl;
			long long k3=k2+k1;
			long long t=(n)/k3;
			//cout << "YES " << t << ' ' << x << ' ' << k1 << ' ' << k2<< endl;
			if (t%k1>=x) {
                a=(t/k1)*k1+x;
				b=(n-k2*a)/k1;
				if (a==0) {
                    k2=k1;
                    k1=k3;
                    continue;
				}
			} else {
				if (t<x) {
					k2=k1;
					k1=k3;
					continue;
				} else {
					a=((t/k1)-1)*(k1)+x;
					b=(n-k2*a)/k1;
					if (a==0) {
                        k2=k1;
                        k1=k3;
                        continue;
					}
				}
			}
			if (b<bestb) {
			bestb = b;
			besta = a;
			} else if (b == bestb && a < besta) {
			besta = a;
			}

			k2 = k1;
			k1 = k3;
		}

		cout << besta << " " << bestb << endl;
	}
    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    return 0;
}
