#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 20;

int tc;
int n, m, b;
int ans;

bool used[size][size];

bool onfield(int x, int y) {
	return x >= 0 && y >= 0 && x < n && y < m;
}

bool could1(int x, int y) {
	if (x < 0 || x + 3 > n || y < 0 || y + 4 > m)
		return false;
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 4; j++)
			if (used[x + i][y + j])
				return false;

	return true;
}

bool could2(int x, int y) {
	if (x < 0 || x + 4 > n || y < 0 || y + 3 > m)
		return false;
	for (int i = 0; i < 4; i++)
		for (int j = 0; j < 3; j++)
			if (used[x + i][y + j])
				return false;

	return true;
}

void change1(int x, int y) {
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 4; j++)
			used[x + i][y + j] ^= 1;
}

void change2(int x, int y) {
	for (int i = 0; i < 4; i++)
		for (int j = 0; j < 3; j++)
			used[x + i][y + j] ^= 1;
}

int cur;

void rec(int cx, int cy) {
	ans = max(ans, cur);
	if (cx >= n)
		return;
	if (cy >= m) {
		rec(cx + 1, 0);
		return;
	}
	if (could1(cx, cy)) {
		cur++;
		change1(cx, cy);
		rec(cx, cy + 1);
		change1(cx, cy);
		cur--;
	}
	if (could2(cx, cy)) {
		cur++;
		change2(cx, cy);
		rec(cx, cy + 1);
		change2(cx, cy);
		cur--;
	}
	rec(cx, cy + 1);
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%d%d%d", &n, &m, &b);
		n--, m--;

		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				used[i][j] = false;
		int x, y, w, h;
		for (int i = 0; i < b; i++) {
			scanf("%d%d%d%d", &x, &y, &w, &h);
			x--, y--;
			for (int p = x; p < x + w; p++)
				for (int q = y; q < y + h; q++)
					if (onfield(p, q))
						used[p][q] = true;
		}

		cur = 0;
		ans = 0;
		rec(0, 0);

		printf("%d\n", ans);
	}

	return 0;
}