#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 100500;
const int MAXK = 131072;

int sumTree[2 * MAXK];
int curk;
int perm[MAXN], ans[MAXN];
int n;

void
add(int pos)
{
	pos += curk - 1;
	while (pos) {
		sumTree[pos]++;
		pos /= 2;
	}
}

int
getSum(int r)
{
	int l = curk;
	r += curk - 1;
	int res = 0;
	while (l < r) {
		if (l % 2 == 1) {
			res += sumTree[l];
		}
		if (r % 2 == 0) {
			res += sumTree[r];
		}
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	if (l == r) {
		res += sumTree[l];
	}
	return res;
}

void
process()
{
	scanf("%d", &n);
	curk = 2;
	while (curk < n) curk *= 2;
	for (int i = 1; i < 2 * curk; ++i) sumTree[i] = 0;
	for (int i = 1; i <= n; ++i) {
		scanf("%d", &perm[i]);
	}
	for (int i = n; i >= 1; --i) {
		ans[i] = getSum(perm[i]);
		add(perm[i]);
	}
	for (int i = 1; i <= n; ++i) {
		printf("%d ", ans[i]);
	}
	puts("");
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	return 0;
}