#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 500;
const int MAXM = 1200;

vector< vector< int > > g;
int n, m;
int dist[MAXN];
int u[MAXM], v[MAXM];
int q[2 * MAXN];
int qh, qt;

void
compute(int from, int edge)
{
	for (int i = 1; i <= n; ++i) {
		dist[i] = -1;
	}
	qh = qt = 0;
	q[qt++] = from;
	dist[from] = 0;
	while (qh < qt) {
		int cur = q[qh++];
		for (vector< int >::iterator it = g[cur].begin(); it != g[cur].end(); ++it) {
			if (*it == edge) {
				continue;
			}
			int to = u[*it] + v[*it] - cur;
			if (dist[to] == -1) {
				dist[to] = dist[cur] + 1;
				q[qt++] = to;
			}
		}
	}
}

void
process()
{
	scanf("%d%d", &n, &m);
	g.clear();
	g.resize(n + 1);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", &u[i], &v[i]);
		g[u[i]].push_back(i);
		g[v[i]].push_back(i);
	}
	int res = 2 * n;
	for (int i = 0; i < m; ++i) {
		compute(u[i], i);
		if (dist[v[i]] != -1) {
			res = min(res, dist[v[i]] + 1);
		}
	}
	printf("%d\n", res);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	return 0;
}