#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 222;

vi g[N];
int d[N][N];
int q[N * N * 2];

inline void solve() {
	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a;
		--b;
		g[a].pb(b);
		g[b].pb(a);
	}
	int ans = inf;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int z = 0; z < n; ++z) {
				d[j][z] = inf;
			}
		}
		int l = 0, r = 0;
		for (int j = 0; j < sz(g[i]); ++j) {
			d[i][g[i][j]] = 1;
			q[r++] = i;
			q[r++] = g[i][j];
		}
		while (l < r) {
			int x = q[l++], y = q[l++];
			for (int i = 0; i < sz(g[y]); ++i) {
				if (g[y][i] == x) {
					continue;
				}
				if (d[y][g[y][i]] > d[x][y] + 1) {
					d[y][g[y][i]] = d[x][y] + 1;
					q[r++] = y;
					q[r++] = g[y][i];
				}
			}
		}
		for (int j = 0; j < sz(g[i]); ++j) {
			ans = min(ans, d[g[i][j]][i]);
		}
	}
	printf("%d\n", ans);
}

int main() {
#ifdef LOCAL42
#define TASK "D"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
