#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 2017;

vector<int> g[maxn];
int dist[maxn], parent[maxn];

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	/*int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int n, k;
		scanf("%d%d", &n, &k);
		vector<int> v(n);
		for (int j = 0; j < n; j++)
			scanf("%d", &v[j]);
		ll l = -1, r = 2 * (ll)1e18 + 2;
		while (r - l > 1) {
			ll mid = (r + l) / 2;
			ll ans = 0;
			for (int j = 0; j < n; j++)
				ans += mid / v[j];
			if (ans < k) l = mid;
			else r = mid;
		}
		printf("%lld\n", r);
	}*/

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int n, m;
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; i++)
			g[i].clear();
		for (int i = 0; i < m; i++) {
			int x, y;
			scanf("%d%d", &x, &y);
			x--, y--;
			g[x].pb(y);
			g[y].pb(x);
		}

		int res = INT_MAX;
		for (int i = 0; i < n; i++) {
			queue<int> q;
			for (int j = 0; j < n; j++) {
				dist[j] = INT_MAX;
				parent[j] = -1;
			}
			dist[i] = 0;
			q.push(i);
			while (!q.empty()) {
				int top = q.front();
				q.pop();
				for (int j = 0; j < sz(g[top]); j++) {
					int next = g[top][j];
					if (dist[next] != INT_MAX) {
						if (parent[top] != next)
							res = min(res, dist[top] + 1 + dist[next]);
					} else {
						dist[next] = dist[top] + 1;
						parent[next] = top;
						q.push(next);
					}
				}
			}
		}
		printf("%d\n", res);

	}

	return 0;
}