#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {

    int ts;
    scanf("%d\n", &ts);
    for (int t = 0; t < ts; t++) {
        int n, k;
        scanf("%d %d\n", &n, &k);

        vi arr(n);
        for (int i = 0 ; i < n;i++) {
            scanf("%d", &arr[i]);
        }

        long long lo = 0,
            hi = 1000100000000000000LL;

        while (lo < hi) {
            long long mid = lo + (hi - lo) / 2;
            long long sum = 0;
            for (int i = 0 ;i < n;i++) {
                sum += mid / arr[i];
                if (sum >= k) {
                    break;
                }
            }

            if (sum >= k) {
                hi = mid;
            } else {
                lo = mid + 1;
            }
        }

        cout << lo << endl;
    }

    return 0;
}
