#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

LL toLL(const string &a)
{
    LL x = 0;
    forn(i, a.size())
        if (a[i] == '1')
            x |= LL(1) << i;
    return x;
}

string toStr(LL x)
{
    string res;
    while (x)
    {
        res += '0' + (x % 2);
        x /= 2;
    }
    if (res.empty())
        res = "0";
    return res;
}

void solve(int test)
{
    cout << "Test " << test << endl;

    string a, b;
    cin >> a >> b;

    reverse(all(a));
    reverse(all(b));

    LL aa = toLL(a);
    LL bb = toLL(b);
    LL rr = aa * bb;

    vector<string> res;
    res.push_back(a);
    res.push_back(b);
    res.push_back(string(max(a.size(), b.size()), '-'));
    forn(i, b.size())
    {
        if (b[i] == '1')
            res.push_back(string(i, ' ') + a);
        else
            res.push_back(string(i, ' ') + string(a.size(), '0'));
    }


    string ans = toStr(rr);
    res.push_back(string(max(res.back().size(), ans.size()), '-'));
    res.push_back(ans);

    int mlen = 0;
    forn(i, res.size())
        mlen = max(mlen, (int)res[i].size());
    forn(i, res.size())
        res[i] += string(mlen - res[i].size(), ' ');
 
    forn(i, res.size())
        reverse(all(res[i]));
    forn(i, res.size())
        cout << res[i] << endl;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    int t; cin >> t;
    forn(i, t)
    {
        if (i)
            cout << endl;
        solve(i + 1);
    }
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif